var Gtop = Gtop || {};
Gtop.Controller = function(funcs) {
    var _parameter = new Gtop.Parameter();
    var _writer = new Gtop.Writer();
    var _decorator = new Gtop.Decorator(funcs);
    var _reloadCount = 0;
    var _requestSaigaiStatusData;
    var _requestNowOnAirListData;
    var _requestRecommendMovieData;
    var _rewriteCounter = 0;
    var _requestRecommendProgramData;
    var _requestContentsNewsData;
    var _requestWebNewsData;
    var _requestRecommendContentsData;
    var _requestAnaFacebookData;
    var _requestProgramBannerData;
    var _curDateTime = null;
    var _serverDateTime = new Useless.ServerDateTime();

    Object.defineProperties(this, {
        parameter: {
            get: function(){ return _parameter; }
            // , set: function(value){ _parameter = value; }
        },
        writer: {
            get: function(){ return _writer; }
            , set: function(value){ _writer = value; }
        },
        reloadCount: {
            get: function(){ return _reloadCount; }
            , set: function(value){ _reloadCount = value; }
        },
        serverDateTime: {
            get: function(){ return _serverDateTime; }
        },
        curDateTime: {
            get: function(){ return _curDateTime; }
            , set: function(value){ _curDateTime = value; }
        }
    });

    // 災害情報対応
    this.checkSaigaiStatus = function (callback) {
        _requestSaigaiStatusData = new Useless.HttpRequestXML({
            url: this.parameter.dataDirs.saigaiDir + '/' + this.parameter.dataFiles.saigaiStatus
            , type: 'GET'
            , data: null
        });
        _requestSaigaiStatusData.done(function () {
            var checkData = _requestSaigaiStatusData.responseXML;
            var saigaiStatus = checkData.documentElement.getElementsByTagName('level')[0].textContent;
            if (saigaiStatus === 'none' || saigaiStatus === 'small' || saigaiStatus === 'big' || saigaiStatus === 'live') {
                callback();
            }
        });
    }

    // Now On Air
    this.requestWriteNowOnAir = function () {
        _requestNowOnAirListData = new Useless.HttpRequestJSON({
            url: this.parameter.dataDirs.tvprogram+'/'+this.parameter.dataFiles.nowOnAirList
            , type: 'GET'
            , data: null
        });
        _requestNowOnAirListData.done(function () {
            _writer.nowOnAirData = _requestNowOnAirListData.responseJSON;
            _writer.writeNowOnAir(function () {
                _decorator.decorateNowOnAir();
            });
            this.requestWriteRecommendMovie();
            if (_reloadCount < 1) {
                this.requestWriteRecommendProgram();
            }
            this.requestWriteContentsNews();
        }.bind(this));
    }

    // イチオシ動画
    this.requestWriteRecommendMovie = function () {
        _requestRecommendMovieData = new Gtop.RecommendMovies({
            url: this.parameter.dataDirs.gtop+'/'+this.parameter.dataFiles.recommendMovie
            , type: 'GET'
            , data: null
        });
        _requestRecommendMovieData.curDateTime = _curDateTime;
        _requestRecommendMovieData.getMovieList(function () {
            var filterRecommendMovieData = _requestRecommendMovieData.movieList;
            if (JSON.stringify(_writer.recommendMovieData) != JSON.stringify(filterRecommendMovieData)) {
                ytIDs = [];
                _writer.recommendMovieData = filterRecommendMovieData;
                _writer.writeRecommendMovie(0, function () {
                    if (_rewriteCounter < 1) {
                        for (var index = 0; index < _writer.recommendMovieData.length; index++) {
                            ytIDs.push(_writer.recommendMovieData[index].recommend_movie_movie_url);
                        }
                        _decorator.decorateRecommendMovie(['startYouTube']);
                    } else {
                        for (var index = 0; index < _writer.recommendMovieData.length; index++) {
                            ytIDs.push(_writer.recommendMovieData[index].recommend_movie_movie_url);
                        }
                        _decorator.decorateRecommendMovie(['changeYouTube']);
                    }
                    _rewriteCounter = 1;
                });
            }
        });
    }

    // イチオシ動画切り替え
    this.requestReWriteRecommendMovie = function () {
        _serverDateTime.execute(function () {
            _parameter.loadPrameter();
            if (_parameter.hostname !== 'www.asahi.co.jp' && _parameter.testMode && _parameter.testTime) {
                _writer.curDateTime = _parameter.testTime;
                _curDateTime = _parameter.testTime;
            } else {
                _writer.curDateTime = _serverDateTime.serverDate;
                _curDateTime = _serverDateTime.serverDate;
            }
            var movieNum = (_rewriteCounter % _writer.recommendMovieData.length);
            _writer.writeRecommendMovie(movieNum, function () {});
            _rewriteCounter++;
        });
    }

    // おすすめ番組
    this.requestWriteRecommendProgram = function () {
        _requestRecommendProgramData = new Useless.HttpRequestJSON({
            url: this.parameter.dataDirs.gtop+'/'+this.parameter.dataFiles.recommendProgram
            , type: 'GET'
            , data: null
        });
        _requestRecommendProgramData.done(function () {
            _writer.recommendProgramData = _requestRecommendProgramData.responseJSON;
            _writer.writeRecommendProgram(function () {
                _decorator.decorateRecommendProgram();
            });
            _reloadCount++;
        });
    }

    // コンテンツニュース
    this.requestWriteContentsNews = function () {
        _requestContentsNewsData = new Useless.HttpRequestJSON({
            url: this.parameter.dataDirs.gtop+'/'+this.parameter.dataFiles.contentsNews
            , type: 'GET'
            , data: null
        });
        _requestContentsNewsData.done(function () {
            _writer.contentsNewsData = _requestContentsNewsData.responseJSON;
            _writer.writeContentsNews(function () {
                if (funcs.contentsNews != undefined) {
                    _decorator.decorateContentsNews();
                }
            });
        });
    }

    // Web News
    this.requestWriteWebNews = function () {
        _requestWebNewsData = new Useless.HttpRequestXML({
            url: this.parameter.dataDirs.rss+'/'+this.parameter.dataFiles.webNews
            , type: 'GET'
            , data: null
        });
        _requestWebNewsData.done(function () {
            _writer.webNewsData = _requestWebNewsData.responseXML;
            _writer.writeWebNews(function () {
                if (funcs.webNews != undefined) {
                    _decorator.decorateWebNews();
                }
            });
        });
    }

    // 旧おすすめコンテンツ系
    this.requestWriteRecommendContents = function () {
        _requestRecommendContentsData = new Useless.HttpRequestJSON({
            url: this.parameter.dataDirs.gtop+'/'+this.parameter.dataFiles.recommendContents
            , type: 'GET'
            , data: null
        });
        _requestAnaFacebookData = new Useless.HttpRequestJSON({
            url: this.parameter.dataDirs.facebookAna+'/'+this.parameter.dataFiles.anaTimeline
            , type: 'GET'
            , data: null
        });
        _requestHiyokoAnaFacebookData = new Useless.HttpRequestJSON({
            url: this.parameter.dataDirs.facebookAna+'/'+this.parameter.dataFiles.anaHiyokoTimeline
            , type: 'GET'
            , data: null
        });
        _requestRecommendContentsData.done(function () {
            _writer.recommendContentsData = _requestRecommendContentsData.responseJSON;
            _writer.writePrsentRecruitment(function () {
                if (funcs.webNews != undefined) {
                    _decorator.decoratePrsentRecruitment();
                }
            });
            _requestAnaFacebookData.done(function () {
                _requestHiyokoAnaFacebookData.done(function () {
                    _writer.anaFacebookData = _requestAnaFacebookData.responseJSON;
                    _writer.anaHiyokoFacebookData = _requestHiyokoAnaFacebookData.responseJSON;
                    _writer.writeAnnouncer();
                });
            });
            _writer.writeVideoDistribution();
        });
    }

    // 番組バナー
    this.requestWriteProgramBanner = function () {
        _requestProgramBannerData = new Useless.HttpRequestJSON({
            url: this.parameter.dataDirs.gtop+'/'+this.parameter.dataFiles.topProgramBanner
            , type: 'GET'
            , data: null
        });
        _requestProgramBannerData.done(function () {
            _writer.programBannerData = _requestProgramBannerData.responseJSON;
            _writer.writeProgramBanner();
        });
    }

}
Gtop.Controller.prototype = {
    execute: function () {
        var self = this;
        this.serverDateTime.execute(function () {
            this.parameter.loadPrameter();
            if (this.parameter.hostname !== 'www.asahi.co.jp' && this.parameter.testMode && this.parameter.testTime) {
                this.writer.curDateTime = this.parameter.testTime;
                this.curDateTime = this.parameter.testTime;
            } else {
                this.writer.curDateTime = this.serverDateTime.serverDate;
                this.curDateTime = this.serverDateTime.serverDate;
            }
            this.checkSaigaiStatus(function () {
                this.requestWriteNowOnAir();
            }.bind(this));
            this.requestWriteWebNews();
            this.requestWriteRecommendContents();
            this.requestWriteProgramBanner();
        }.bind(self));

        var reExecute = function () {
            self.serverDateTime.execute(function(){
                this.parameter.loadPrameter();
                if (this.parameter.hostname !== 'www.asahi.co.jp' && this.parameter.testMode && this.parameter.testTime) {
                    this.writer.curDateTime = this.parameter.testTime;
                    this.curDateTime = this.parameter.testTime;
                } else {
                    this.writer.curDateTime = this.serverDateTime.serverDate;
                    this.curDateTime = this.serverDateTime.serverDate;
                }
                this.checkSaigaiStatus(function () {
                    this.requestWriteNowOnAir();
                }.bind(this));
            }.bind(self));
            setTimeout(reExecute, 30000);
        }
        setTimeout(reExecute, 30000);

        var reSize = function () {
            var div_ana = document.getElementById("div_ana");
            var img_ana = document.getElementById("img_ana");
            if (typeof(div_ana) == 'undefined' || typeof(img_ana) == 'undefined' || div_ana == null || img_ana == null) {
                setTimeout(reSize, 500);
            } else {
                var img_width = img_ana.width;
                var img_height = img_ana.height;
                if (typeof(img_width) == 'undefined' && typeof(img_height) == 'undefined') {
                    setTimeout(reSize, 500);
                } else {
                    if (img_width < img_height) {
                        if (div_ana.classList.contains("thumb-contents-top") === false) {
                            div_ana.classList.add("thumb-contents-top");
                        }
                    }
                    setTimeout(reSize, 59000);
                }
            }
        }
        setTimeout(reSize, 1000);

    }
}